Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

------------------------------------------------------
-- MODULE DESCRIPTION
-- 
------------------------------------------------------

entity RDM_Bus_Interface is 
	port( 
			Diag_Data		: in std_logic_vector(15 downto 0);
			STROBE			: in std_logic;
			rdmLD			: in std_logic_vector(15 downto 0);
			rdmLA			: in std_logic_vector(17 downto 0);
			rdmMEM_WE_n		: in std_logic;
			rdmMEM_OE_n		: in std_logic;
			rdmMEM_CS_n		: in std_logic;
			rdmEna_Localbus : in std_logic;
			
			LA				: out std_logic_vector(17 downto 0);
			LD				: out std_logic_vector(15 downto 0);
			Drive_Bus		: out std_logic;
			MEM_WE_n		: out std_logic;
			MEM_OE_n		: out std_logic;
			MEM_CS_n		: out std_logic			
		);
	end RDM_Bus_Interface ;
	
architecture main of RDM_Bus_Interface  is
	
	
	
		
--========================================================================
--========================================================================
--                    B E G I N 
--========================================================================
--========================================================================	
begin

MUX_CONTROL: 
process(rdmEna_Localbus, rdmLD, rdmLA, rdmMEM_WE_n, rdmMEM_OE_n, rdmMEM_CS_n,
		Diag_Data, STROBE)
begin
	if   (rdmEna_Localbus = '1') then
		LD			<= rdmLD;			
		LA			<= rdmLA;			
		MEM_WE_n	<= rdmMEM_WE_n;		
		MEM_OE_n	<= rdmMEM_OE_n;		
		MEM_CS_n	<= rdmMEM_CS_n;
		Drive_Bus	<= rdmMEM_OE_n;		
	else
		LD			<= Diag_Data;		
		LA			<= (others => '0');			
		MEM_WE_n	<= '1';		
		MEM_OE_n	<= STROBE;		
		MEM_CS_n	<= '1';	
		Drive_Bus	<= '1';		
	end if;
end process;
end;   